# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AzureLargeInstanceHardwareTypeNamesEnum',
    'AzureLargeInstancePowerStateEnum',
    'AzureLargeInstanceSizeNamesEnum',
    'ManagedServiceIdentityType',
]


class AzureLargeInstanceHardwareTypeNamesEnum(str, Enum):
    """
    the hardware type of the storage instance
    """
    CISCO_UCS = "Cisco_UCS"
    """
    Hardware type of UCS from vendor Cisco
    """
    HPE = "HPE"
    """
    Hardware type of HPE from vendor Hewlett Packard Enterprise
    """
    SDFLEX = "SDFLEX"
    """
    Hardware type of SDFLEX
    """


class AzureLargeInstancePowerStateEnum(str, Enum):
    """
    Resource power state
    """
    STARTING = "starting"
    """
    Starting means that the Azure Large Instance resource is turning on.
    """
    STARTED = "started"
    """
    Started means that the Azure Large Instance resource has been powered on.
    """
    STOPPING = "stopping"
    """
    Stopping means that the Azure Large Instance resource is shutting down.
    """
    STOPPED = "stopped"
    """
    Stopped means that the Azure Large Instance resource has shut down.
    """
    RESTARTING = "restarting"
    """
    Restarting means that the Azure Large Instance resource is restarting.
    """
    UNKNOWN = "unknown"
    """
    Unknown means that the state of the Azure Large Instance is unknown.
    """


class AzureLargeInstanceSizeNamesEnum(str, Enum):
    """
    Specifies the Azure Large Instance SKU.
    """
    S72M = "S72m"
    """
    Type I class SKU that can't be purchased anymore
    """
    S144M = "S144m"
    """
    Type I class SKU that can't be purchased anymore
    """
    S72 = "S72"
    """
    Type I class SKU that can't be purchased anymore
    """
    S144 = "S144"
    """
    Type I class SKU that can't be purchased anymore
    """
    S192 = "S192"
    """
    Type I class SKU that can't be purchased anymore
    """
    S192M = "S192m"
    """
    Type I class SKU that can't be purchased anymore
    """
    S192XM = "S192xm"
    """
    Type I class SKU that can't be purchased anymore
    """
    S96 = "S96"
    """
    2 sockets, 96 CPU threads, 48 CPU cores, 768 GB total memory, 768 GB DRAM, 3.0 TB storage, Cisco_UCS hardware type
    """
    S112 = "S112"
    """
    No longer offered or used.
    """
    S224 = "S224"
    """
    4 sockets, 224 CPU threads, 112 CPU cores, 3 TB total memory, 3 TB DRAM, 6.3 TB storage, Cisco_UCS hardware type
    """
    S224M = "S224m"
    """
    4 sockets, 224 CPU threads, 112 CPU cores, 6 TB total memory, 6 TB DRAM, 10.5 TB storage, Cisco_UCS hardware type
    """
    S224OM = "S224om"
    """
    4 sockets, 224 CPU threads, 112 CPU cores, 6 TB total memory, 3 TB DRAM, 3 TB memory optane, 10.5 TB storage, Cisco_UCS hardware type
    """
    S224OO = "S224oo"
    """
    4 sockets, 224 CPU threads, 112 CPU cores, 4.5 TB total memory, 1.5 TB DRAM, 3 TB memory optane, 8.4 TB storage, Cisco_UCS hardware type
    """
    S224OOM = "S224oom"
    """
    4 sockets, 224 CPU threads, 112 CPU cores, 9 TB total memory, 3 TB DRAM, 6 TB memory optane, 14.8 TB storage, Cisco_UCS hardware type
    """
    S224OOO = "S224ooo"
    """
    4 sockets, 224 CPU threads, 112 CPU cores, 7.5TB total memory, 1.5 TB DRAM, 6 TB memory optane, 12.7 TB storage, Cisco_UCS hardware type
    """
    S224SE = "S224se"
    """
    4 sockets, 448 CPU threads, 6 TB total memory, SDFLEX hardware type
    """
    S384 = "S384"
    """
    8 sockets, 384 CPU threads, 192 CPU cores, 4 TB total memory, 4 TB DRAM, 16 TB storage, HPEMc990x hardware type
    """
    S384M = "S384m"
    """
    8 sockets, 384 CPU threads, 192 CPU cores, 6 TB total memory, 6 TB DRAM, 18 TB storage, HPEMc990x hardware type
    """
    S384XM = "S384xm"
    """
    8 sockets, 384 CPU threads, 192 CPU cores, 8 TB total memory, 8 TB DRAM, 22 TB storage, HPEMc990x hardware type
    """
    S384XXM = "S384xxm"
    """
    8 sockets, 384 CPU threads, 12 TB total memory, HPEMc990x hardware type
    """
    S448 = "S448"
    """
    8 sockets, 448 CPU threads, 224 CPU cores, 6 TB total memory, 6 TB DRAM, 10.5 TB storage, SDFLEX hardware type
    """
    S448M = "S448m"
    """
    8 sockets, 448 CPU threads, 224 CPU cores, 12 TB total memory, 12 TB DRAM, 18.9 TB storage, SDFLEX hardware type
    """
    S448OM = "S448om"
    """
    8 sockets, 448 CPU threads, 224 CPU cores, 12 TB total memory, 6 TB DRAM, 6 TB memory optane, 18.9 TB storage, SDFLEX hardware type
    """
    S448OO = "S448oo"
    """
    8 sockets, 448 CPU threads, 224 CPU cores, 9 TB total memory, 3 TB DRAM, 6 TB memory optane, 14.8 TB storage, SDFLEX hardware type
    """
    S448OOM = "S448oom"
    """
    8 sockets, 448 CPU threads, 224 CPU cores, 18 TB total memory, 6 TB DRAM, 12 memory optane, 27.4 TB storage, SDFLEX hardware type
    """
    S448OOO = "S448ooo"
    """
    8 sockets, 448 CPU threads, 224 CPU cores, 15 TB total memory, 3 TB DRAM, 12 memory optane, 23.2 TB storage, SDFLEX hardware type
    """
    S448SE = "S448se"
    """
    8 sockets, 448 CPU threads, 12 TB total memory, SDFLEX hardware type
    """
    S576M = "S576m"
    """
    12 sockets, 576 CPU threads, 288 CPU cores, 12 TB total memory, 12 TB DRAM, 28 TB storage, HPEMc990x hardware type
    """
    S576XM = "S576xm"
    """
    12 sockets, 576 CPU threads, 288 CPU cores, 18 TB total memory, HPEMc990x hardware type
    """
    S672 = "S672"
    """
    12 sockets, 672 CPU threads, 336 CPU cores, 9 TB total memory, 9 TB DRAM, 14.7 TB storage, SDFLEX hardware type
    """
    S672M = "S672m"
    """
    12 sockets, 672 CPU threads, 336 CPU cores, 18 TB total memory, 18 TB DRAM, 27.4 TB storage, SDFLEX hardware type
    """
    S672OM = "S672om"
    """
    12 sockets, 672 CPU threads, 336 CPU cores, 18 TB total memory, 9 TB DRAM, 9 TB memory optane, 27.4 TB storage, SDFLEX hardware type
    """
    S672OO = "S672oo"
    """
    12 sockets, 672 CPU threads, 336 CPU cores, 13.5 TB total memory, 4.5 TB DRAM, 9 TB memory optane, 21.1 TB storage, SDFLEX hardware type
    """
    S672OOM = "S672oom"
    """
    12 sockets, 672 CPU threads, 336 CPU cores, 27 TB total memory, 9 TB DRAM, 18 TB memory optane, 40 TB storage, SDFLEX hardware type
    """
    S672OOO = "S672ooo"
    """
    12 sockets, 672 CPU threads, 336 CPU cores, 22.5 TB total memory, 4.5 TB DRAM, 18 TB memory optane, 33.7 TB storage, SDFLEX hardware type
    """
    S768 = "S768"
    """
    No longer offered or used.
    """
    S768M = "S768m"
    """
    16 sockets, 768 CPU threads, 384 CPU cores, 16 TB total memory, 16 TB DRAM, 36 TB storage, HPEMc990x hardware type
    """
    S768XM = "S768xm"
    """
    16 sockets, 768 CPU threads, 384 CPU cores, 24 TB total memory, 24 TB DRAM, 56 TB storage, HPEMc990x hardware type
    """
    S896 = "S896"
    """
    16 sockets, 896 CPU threads, 448 CPU cores, 12 TB total memory, 12 TB DRAM, 18.9 TB storage, SDFLEX hardware type
    """
    S896M = "S896m"
    """
    16 sockets, 896 CPU threads, 448 CPU cores, 24 TB	total memory, 24 TB DRAM, 35.8 TB storage, SDFLEX hardware type
    """
    S896OM = "S896om"
    """
    16 sockets, 896 CPU threads, 448 CPU cores, 24 TB	total memory, 12 TB DRAM, 12 TB memory optane, 35.8 TB storage, SDFLEX hardware type
    """
    S896OO = "S896oo"
    """
    16 sockets, 896 CPU threads, 448 CPU cores, 18 TB  total memory, 6 TB DRAM, 12 TB memory optane, 27.4 TB storage, SDFLEX hardware type
    """
    S896OOM = "S896oom"
    """
    16 sockets, 896 CPU threads, 448 CPU cores, 36 TB total memory, 12 TB DRAM, 24 TB memory optane, 52.7 TB storage, SDFLEX hardware type
    """
    S896OOO = "S896ooo"
    """
    16 sockets, 896 CPU threads, 448 CPU cores, 30 TB total memory, 6 TB DRAM, 24 TB memory optane, 44.3 TB storage, SDFLEX hardware type
    """
    S960M = "S960m"
    """
    20 sockets, 960 CPU threads, 480 CPU cores, 20 TB total memory, 20 TB DRAM, 46 TB storage, HPEMc990x hardware type
    """


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"
