# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetNGroupResult',
    'AwaitableGetNGroupResult',
    'get_n_group',
    'get_n_group_output',
]

@pulumi.output_type
class GetNGroupResult:
    """
    Describes a nGroup.
    """
    def __init__(__self__, container_group_profiles=None, elastic_profile=None, id=None, identity=None, location=None, name=None, provisioning_state=None, system_data=None, tags=None, type=None, zones=None):
        if container_group_profiles and not isinstance(container_group_profiles, list):
            raise TypeError("Expected argument 'container_group_profiles' to be a list")
        pulumi.set(__self__, "container_group_profiles", container_group_profiles)
        if elastic_profile and not isinstance(elastic_profile, dict):
            raise TypeError("Expected argument 'elastic_profile' to be a dict")
        pulumi.set(__self__, "elastic_profile", elastic_profile)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if identity and not isinstance(identity, dict):
            raise TypeError("Expected argument 'identity' to be a dict")
        pulumi.set(__self__, "identity", identity)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if zones and not isinstance(zones, list):
            raise TypeError("Expected argument 'zones' to be a list")
        pulumi.set(__self__, "zones", zones)

    @property
    @pulumi.getter(name="containerGroupProfiles")
    def container_group_profiles(self) -> Optional[Sequence['outputs.ContainerGroupProfileStubResponse']]:
        """
        The Container Group Profiles that could be used in a nGroup.
        """
        return pulumi.get(self, "container_group_profiles")

    @property
    @pulumi.getter(name="elasticProfile")
    def elastic_profile(self) -> Optional['outputs.ElasticProfileResponse']:
        """
        The elastic profile.
        """
        return pulumi.get(self, "elastic_profile")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The resource id.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def identity(self) -> Optional['outputs.NGroupIdentityResponse']:
        """
        The identity of the nGroup, if configured.
        """
        return pulumi.get(self, "identity")

    @property
    @pulumi.getter
    def location(self) -> Optional[str]:
        """
        The resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The provisioning state, which only appears in the response.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        The resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The resource type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def zones(self) -> Optional[Sequence[str]]:
        """
        The zones for the container group.
        """
        return pulumi.get(self, "zones")


class AwaitableGetNGroupResult(GetNGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNGroupResult(
            container_group_profiles=self.container_group_profiles,
            elastic_profile=self.elastic_profile,
            id=self.id,
            identity=self.identity,
            location=self.location,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type,
            zones=self.zones)


def get_n_group(ngroups_name: Optional[str] = None,
                resource_group_name: Optional[str] = None,
                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNGroupResult:
    """
    Get the properties of the specified n group.
    Azure REST API version: 2024-09-01-preview.


    :param str ngroups_name: The N Groups name.
    :param str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['ngroupsName'] = ngroups_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:containerinstance:getNGroup', __args__, opts=opts, typ=GetNGroupResult).value

    return AwaitableGetNGroupResult(
        container_group_profiles=pulumi.get(__ret__, 'container_group_profiles'),
        elastic_profile=pulumi.get(__ret__, 'elastic_profile'),
        id=pulumi.get(__ret__, 'id'),
        identity=pulumi.get(__ret__, 'identity'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'),
        zones=pulumi.get(__ret__, 'zones'))


@_utilities.lift_output_func(get_n_group)
def get_n_group_output(ngroups_name: Optional[pulumi.Input[str]] = None,
                       resource_group_name: Optional[pulumi.Input[str]] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNGroupResult]:
    """
    Get the properties of the specified n group.
    Azure REST API version: 2024-09-01-preview.


    :param str ngroups_name: The N Groups name.
    :param str resource_group_name: The name of the resource group.
    """
    ...
