# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'DockerfileGenerationMode',
    'GenerationLanguage',
    'GenerationManifestType',
    'ManifestGenerationMode',
    'ManifestType',
    'QuickStartTemplateType',
    'WorkflowRunStatus',
]


class DockerfileGenerationMode(str, Enum):
    """
    The mode of generation to be used for generating Dockerfiles.
    """
    ENABLED = "enabled"
    """
    Dockerfiles will be generated
    """
    DISABLED = "disabled"
    """
    Dockerfiles will not be generated
    """


class GenerationLanguage(str, Enum):
    """
    The programming language used.
    """
    CLOJURE = "clojure"
    """
    clojure language
    """
    CSHARP = "csharp"
    """
    csharp language
    """
    ERLANG = "erlang"
    """
    erlang language
    """
    GO = "go"
    """
    go language
    """
    GOMODULE = "gomodule"
    """
    gomodule language
    """
    GRADLE = "gradle"
    """
    gradle language
    """
    JAVA = "java"
    """
    java language
    """
    JAVASCRIPT = "javascript"
    """
    javascript language
    """
    PHP = "php"
    """
    php language
    """
    PYTHON = "python"
    """
    python language
    """
    RUBY = "ruby"
    """
    ruby language
    """
    RUST = "rust"
    """
    rust language
    """
    SWIFT = "swift"
    """
    swift language
    """


class GenerationManifestType(str, Enum):
    """
    Determines the type of manifests to be generated.
    """
    HELM = "helm"
    """
    Helm manifests
    """
    KUBE = "kube"
    """
    Kubernetes manifests
    """


class ManifestGenerationMode(str, Enum):
    """
    The mode of generation to be used for generating Manifest.
    """
    ENABLED = "enabled"
    """
    Manifests will be generated
    """
    DISABLED = "disabled"
    """
    Manifests will not be generated
    """


class ManifestType(str, Enum):
    """
    Determines the type of manifests within the repository.
    """
    HELM = "helm"
    """
    Repositories using helm
    """
    KUBE = "kube"
    """
    Repositories using kubernetes manifests
    """


class QuickStartTemplateType(str, Enum):
    """
    Determines the authorization status of requests.
    """
    NONE = "None"
    """
    The template has not use quick start template
    """
    HCI = "HCI"
    """
    The template use quick start template of HCI
    """
    HCIAKS = "HCIAKS"
    """
    The template use quick start template of HCI and AKS
    """
    HCIARCVM = "HCIARCVM"
    """
    The template use quick start template of HCI and ArcVM
    """
    ALL = "ALL"
    """
    The template use quick start template of All supported products
    """


class WorkflowRunStatus(str, Enum):
    """
    Describes the status of the workflow run
    """
    QUEUED = "queued"
    """
    Workflow run is queued
    """
    INPROGRESS = "inprogress"
    """
    Workflow run is inprogress
    """
    COMPLETED = "completed"
    """
    Workflow run is completed
    """
