# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuthenticationMethod',
    'DataPointsObservabilityMode',
    'EventsObservabilityMode',
    'Format',
    'SchemaType',
    'SystemAssignedServiceIdentityType',
    'TopicRetainType',
    'UserAuthenticationMode',
]


class AuthenticationMethod(str, Enum):
    """
    The method to authenticate the user of the client at the server.
    """
    ANONYMOUS = "Anonymous"
    """
    The user authentication method is anonymous.
    """
    CERTIFICATE = "Certificate"
    """
    The user authentication method is an x509 certificate.
    """
    USERNAME_PASSWORD = "UsernamePassword"
    """
    The user authentication method is a username and password.
    """


class DataPointsObservabilityMode(str, Enum):
    """
    An indication of how the data point should be mapped to OpenTelemetry.
    """
    NONE = "none"
    """
    No mapping to OpenTelemetry.
    """
    COUNTER = "counter"
    """
    Map as counter to OpenTelemetry.
    """
    GAUGE = "gauge"
    """
    Map as gauge to OpenTelemetry.
    """
    HISTOGRAM = "histogram"
    """
    Map as histogram to OpenTelemetry.
    """
    LOG = "log"
    """
    Map as log to OpenTelemetry.
    """


class EventsObservabilityMode(str, Enum):
    """
    An indication of how the event should be mapped to OpenTelemetry.
    """
    NONE = "none"
    """
    No mapping to OpenTelemetry.
    """
    LOG = "log"
    """
    Map as log to OpenTelemetry.
    """


class Format(str, Enum):
    """
    Format of the schema.
    """
    JSON_SCHEMA_DRAFT7 = "JsonSchema/draft-07"
    """
    JSON Schema version draft 7 format
    """
    DELTA_1_0 = "Delta/1.0"
    """
    Delta format
    """


class SchemaType(str, Enum):
    """
    Type of the schema.
    """
    MESSAGE_SCHEMA = "MessageSchema"
    """
    Message Schema schema type
    """


class SystemAssignedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (either system assigned, or none).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"


class TopicRetainType(str, Enum):
    """
    When set to 'Keep', messages published to an MQTT broker will have the retain flag set. Default: 'Never'.
    """
    KEEP = "Keep"
    """
    Retain the messages.
    """
    NEVER = "Never"
    """
    Never retain messages.
    """


class UserAuthenticationMode(str, Enum):
    """
    Defines the method to authenticate the user of the client at the server.
    """
    ANONYMOUS = "Anonymous"
    """
    The user authentication method is anonymous.
    """
    CERTIFICATE = "Certificate"
    """
    The user authentication method is an x509 certificate.
    """
    USERNAME_PASSWORD = "UsernamePassword"
    """
    The user authentication method is a username and password.
    """
