# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AzureDevOpsPermissionType',
    'CachingType',
    'LogonType',
    'ManagedServiceIdentityType',
    'OsDiskStorageAccountType',
    'ProvisioningState',
    'StorageAccountType',
]


class AzureDevOpsPermissionType(str, Enum):
    """
    Determines who has admin permissions to the Azure DevOps pool.
    """
    INHERIT = "Inherit"
    """
    Pool will inherit permissions from the project or organization.
    """
    CREATOR_ONLY = "CreatorOnly"
    """
    Only the pool creator will be an admin of the pool.
    """
    SPECIFIC_ACCOUNTS = "SpecificAccounts"
    """
    Only the specified accounts will be admins of the pool.
    """


class CachingType(str, Enum):
    """
    The type of caching to be enabled for the data disks. The default value for caching is readwrite. For information about the caching options see: https://blogs.msdn.microsoft.com/windowsazurestorage/2012/06/27/exploring-windows-azure-drives-disks-and-images/.
    """
    NONE = "None"
    """
    Don't use host caching.
    """
    READ_ONLY = "ReadOnly"
    """
    For workloads that only do read operations.
    """
    READ_WRITE = "ReadWrite"
    """
    For workloads that do a balance of read and write operations.
    """


class LogonType(str, Enum):
    """
    Determines how the service should be run. By default, this will be set to Service.
    """
    SERVICE = "Service"
    """
    Run as a service.
    """
    INTERACTIVE = "Interactive"
    """
    Run in interactive mode.
    """


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


class OsDiskStorageAccountType(str, Enum):
    """
    The Azure SKU name of the machines in the pool.
    """
    STANDARD = "Standard"
    """
    Standard OS disk type.
    """
    PREMIUM = "Premium"
    """
    Premium OS disk type.
    """
    STANDARD_SSD = "StandardSSD"
    """
    Standard SSD OS disk type.
    """


class ProvisioningState(str, Enum):
    """
    The status of the current operation.
    """
    SUCCEEDED = "Succeeded"
    """
    Represents a succeeded operation.
    """
    FAILED = "Failed"
    """
    Represents a failed operation.
    """
    CANCELED = "Canceled"
    """
    Represents a canceled operation.
    """
    PROVISIONING = "Provisioning"
    """
    Represents a pending operation.
    """
    UPDATING = "Updating"
    """
    Represents a pending operation.
    """
    DELETING = "Deleting"
    """
    Represents an operation under deletion.
    """
    ACCEPTED = "Accepted"
    """
    Represents an accepted operation.
    """


class StorageAccountType(str, Enum):
    """
    The storage Account type to be used for the data disk. If omitted, the default is "standard_lrs".
    """
    STANDARD_LRS = "standard_lrs"
    """
    The data disk should use standard locally redundant storage.
    """
    PREMIUM_LRS = "premium_lrs"
    """
    The data disk should use premium locally redundant storage.
    """
    STANDARD_SSDLRS = "standardssd_lrs"
    """
    The data disk should use standard SSD locally redundant storage.
    """
    PREMIUM_ZRS = "premium_zrs"
    """
    The data disk should use premium SSD zonal redundant storage.
    """
    STANDARD_SSDZRS = "standardssd_zrs"
    """
    The data disk should use standard SSD zonal redundant storage.
    """
