# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from . import outputs

__all__ = [
    'ListArtifactStorePrivateEndPointsResult',
    'AwaitableListArtifactStorePrivateEndPointsResult',
    'list_artifact_store_private_end_points',
    'list_artifact_store_private_end_points_output',
]

@pulumi.output_type
class ListArtifactStorePrivateEndPointsResult:
    """
    List of manual private endpoints.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> str:
        """
        The URI to get the next set of results.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.ArtifactStorePrivateEndPointsFormatResponse']]:
        """
        A list of private endpoints.
        """
        return pulumi.get(self, "value")


class AwaitableListArtifactStorePrivateEndPointsResult(ListArtifactStorePrivateEndPointsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListArtifactStorePrivateEndPointsResult(
            next_link=self.next_link,
            value=self.value)


def list_artifact_store_private_end_points(artifact_store_name: Optional[str] = None,
                                           publisher_name: Optional[str] = None,
                                           resource_group_name: Optional[str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListArtifactStorePrivateEndPointsResult:
    """
    List manual private endpoints on artifact stores


    :param str artifact_store_name: The name of the artifact store.
    :param str publisher_name: The name of the publisher.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['artifactStoreName'] = artifact_store_name
    __args__['publisherName'] = publisher_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:hybridnetwork/v20240415:listArtifactStorePrivateEndPoints', __args__, opts=opts, typ=ListArtifactStorePrivateEndPointsResult).value

    return AwaitableListArtifactStorePrivateEndPointsResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))


@_utilities.lift_output_func(list_artifact_store_private_end_points)
def list_artifact_store_private_end_points_output(artifact_store_name: Optional[pulumi.Input[str]] = None,
                                                  publisher_name: Optional[pulumi.Input[str]] = None,
                                                  resource_group_name: Optional[pulumi.Input[str]] = None,
                                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListArtifactStorePrivateEndPointsResult]:
    """
    List manual private endpoints on artifact stores


    :param str artifact_store_name: The name of the artifact store.
    :param str publisher_name: The name of the publisher.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    ...
