# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['MobileNetworkArgs', 'MobileNetwork']

@pulumi.input_type
class MobileNetworkArgs:
    def __init__(__self__, *,
                 public_land_mobile_network_identifier: pulumi.Input['PlmnIdArgs'],
                 resource_group_name: pulumi.Input[str],
                 identity: Optional[pulumi.Input['ManagedServiceIdentityArgs']] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 mobile_network_name: Optional[pulumi.Input[str]] = None,
                 public_land_mobile_networks: Optional[pulumi.Input[Sequence[pulumi.Input['PublicLandMobileNetworkArgs']]]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a MobileNetwork resource.
        :param pulumi.Input['PlmnIdArgs'] public_land_mobile_network_identifier: The unique public land mobile network identifier for the network. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input['ManagedServiceIdentityArgs'] identity: The identity used to retrieve any private keys used for SUPI concealment from Azure key vault.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] mobile_network_name: The name of the mobile network.
        :param pulumi.Input[Sequence[pulumi.Input['PublicLandMobileNetworkArgs']]] public_land_mobile_networks: A list of public land mobile networks including their identifiers. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "public_land_mobile_network_identifier", public_land_mobile_network_identifier)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if identity is not None:
            pulumi.set(__self__, "identity", identity)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if mobile_network_name is not None:
            pulumi.set(__self__, "mobile_network_name", mobile_network_name)
        if public_land_mobile_networks is not None:
            pulumi.set(__self__, "public_land_mobile_networks", public_land_mobile_networks)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="publicLandMobileNetworkIdentifier")
    def public_land_mobile_network_identifier(self) -> pulumi.Input['PlmnIdArgs']:
        """
        The unique public land mobile network identifier for the network. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        """
        return pulumi.get(self, "public_land_mobile_network_identifier")

    @public_land_mobile_network_identifier.setter
    def public_land_mobile_network_identifier(self, value: pulumi.Input['PlmnIdArgs']):
        pulumi.set(self, "public_land_mobile_network_identifier", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def identity(self) -> Optional[pulumi.Input['ManagedServiceIdentityArgs']]:
        """
        The identity used to retrieve any private keys used for SUPI concealment from Azure key vault.
        """
        return pulumi.get(self, "identity")

    @identity.setter
    def identity(self, value: Optional[pulumi.Input['ManagedServiceIdentityArgs']]):
        pulumi.set(self, "identity", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="mobileNetworkName")
    def mobile_network_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the mobile network.
        """
        return pulumi.get(self, "mobile_network_name")

    @mobile_network_name.setter
    def mobile_network_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mobile_network_name", value)

    @property
    @pulumi.getter(name="publicLandMobileNetworks")
    def public_land_mobile_networks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PublicLandMobileNetworkArgs']]]]:
        """
        A list of public land mobile networks including their identifiers. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        """
        return pulumi.get(self, "public_land_mobile_networks")

    @public_land_mobile_networks.setter
    def public_land_mobile_networks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PublicLandMobileNetworkArgs']]]]):
        pulumi.set(self, "public_land_mobile_networks", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class MobileNetwork(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 identity: Optional[pulumi.Input[Union['ManagedServiceIdentityArgs', 'ManagedServiceIdentityArgsDict']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 mobile_network_name: Optional[pulumi.Input[str]] = None,
                 public_land_mobile_network_identifier: Optional[pulumi.Input[Union['PlmnIdArgs', 'PlmnIdArgsDict']]] = None,
                 public_land_mobile_networks: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PublicLandMobileNetworkArgs', 'PublicLandMobileNetworkArgsDict']]]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Mobile network resource.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['ManagedServiceIdentityArgs', 'ManagedServiceIdentityArgsDict']] identity: The identity used to retrieve any private keys used for SUPI concealment from Azure key vault.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] mobile_network_name: The name of the mobile network.
        :param pulumi.Input[Union['PlmnIdArgs', 'PlmnIdArgsDict']] public_land_mobile_network_identifier: The unique public land mobile network identifier for the network. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        :param pulumi.Input[Sequence[pulumi.Input[Union['PublicLandMobileNetworkArgs', 'PublicLandMobileNetworkArgsDict']]]] public_land_mobile_networks: A list of public land mobile networks including their identifiers. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MobileNetworkArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Mobile network resource.

        :param str resource_name: The name of the resource.
        :param MobileNetworkArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MobileNetworkArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 identity: Optional[pulumi.Input[Union['ManagedServiceIdentityArgs', 'ManagedServiceIdentityArgsDict']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 mobile_network_name: Optional[pulumi.Input[str]] = None,
                 public_land_mobile_network_identifier: Optional[pulumi.Input[Union['PlmnIdArgs', 'PlmnIdArgsDict']]] = None,
                 public_land_mobile_networks: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PublicLandMobileNetworkArgs', 'PublicLandMobileNetworkArgsDict']]]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MobileNetworkArgs.__new__(MobileNetworkArgs)

            __props__.__dict__["identity"] = identity
            __props__.__dict__["location"] = location
            __props__.__dict__["mobile_network_name"] = mobile_network_name
            if public_land_mobile_network_identifier is None and not opts.urn:
                raise TypeError("Missing required property 'public_land_mobile_network_identifier'")
            __props__.__dict__["public_land_mobile_network_identifier"] = public_land_mobile_network_identifier
            __props__.__dict__["public_land_mobile_networks"] = public_land_mobile_networks
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["service_key"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:mobilenetwork:MobileNetwork"), pulumi.Alias(type_="azure-native:mobilenetwork/v20220301preview:MobileNetwork"), pulumi.Alias(type_="azure-native:mobilenetwork/v20220401preview:MobileNetwork"), pulumi.Alias(type_="azure-native:mobilenetwork/v20221101:MobileNetwork"), pulumi.Alias(type_="azure-native:mobilenetwork/v20230601:MobileNetwork"), pulumi.Alias(type_="azure-native:mobilenetwork/v20230901:MobileNetwork"), pulumi.Alias(type_="azure-native:mobilenetwork/v20240401:MobileNetwork")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(MobileNetwork, __self__).__init__(
            'azure-native:mobilenetwork/v20240201:MobileNetwork',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'MobileNetwork':
        """
        Get an existing MobileNetwork resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = MobileNetworkArgs.__new__(MobileNetworkArgs)

        __props__.__dict__["identity"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["public_land_mobile_network_identifier"] = None
        __props__.__dict__["public_land_mobile_networks"] = None
        __props__.__dict__["service_key"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return MobileNetwork(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def identity(self) -> pulumi.Output[Optional['outputs.ManagedServiceIdentityResponse']]:
        """
        The identity used to retrieve any private keys used for SUPI concealment from Azure key vault.
        """
        return pulumi.get(self, "identity")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The provisioning state of the mobile network resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="publicLandMobileNetworkIdentifier")
    def public_land_mobile_network_identifier(self) -> pulumi.Output['outputs.PlmnIdResponse']:
        """
        The unique public land mobile network identifier for the network. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        """
        return pulumi.get(self, "public_land_mobile_network_identifier")

    @property
    @pulumi.getter(name="publicLandMobileNetworks")
    def public_land_mobile_networks(self) -> pulumi.Output[Optional[Sequence['outputs.PublicLandMobileNetworkResponse']]]:
        """
        A list of public land mobile networks including their identifiers. If both 'publicLandMobileNetworks' and 'publicLandMobileNetworkIdentifier' are specified, then the 'publicLandMobileNetworks' will take precedence.
        """
        return pulumi.get(self, "public_land_mobile_networks")

    @property
    @pulumi.getter(name="serviceKey")
    def service_key(self) -> pulumi.Output[str]:
        """
        The mobile network resource identifier
        """
        return pulumi.get(self, "service_key")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

