# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ExporterType',
    'ExtendedLocationType',
    'ExternalNetworkingMode',
    'JsonMapperElement',
    'PipelineType',
    'ProcessorType',
    'ReceiverType',
    'StreamEncodingType',
    'SyslogProtocol',
]


class ExporterType(str, Enum):
    """
    The type of exporter.
    """
    AZURE_MONITOR_WORKSPACE_LOGS = "AzureMonitorWorkspaceLogs"
    """
    Export logs to Azure Monitor Workspace.
    """
    PIPELINE_GROUP = "PipelineGroup"
    """
    Export data to another pipeline group instance.
    """


class ExtendedLocationType(str, Enum):
    """
    The type of the extended location.
    """
    EDGE_ZONE = "EdgeZone"
    """
    Azure Edge Zones location type
    """
    CUSTOM_LOCATION = "CustomLocation"
    """
    Azure Custom Locations type
    """


class ExternalNetworkingMode(str, Enum):
    """
    External networking mode.
    """
    LOAD_BALANCER_ONLY = "LoadBalancerOnly"
    """
    Load balancer only.
    """


class JsonMapperElement(str, Enum):
    """
    Define the destination's element. The element is the body or the attributes of the message, to which the json array mapper will write the output map.
    """
    BODY = "body"
    """
    Read or write the json array from or to the body of the message.
    """
    ATTRIBUTES = "attributes"
    """
    Read or write the json array from or to the attributes of the message.
    """


class PipelineType(str, Enum):
    """
    The type of pipeline
    """
    LOGS = "Logs"
    """
    Pipeline for logs telemetry.
    """


class ProcessorType(str, Enum):
    """
    The type of processor.
    """
    BATCH = "Batch"
    """
    Batch processor.
    """


class ReceiverType(str, Enum):
    """
    The type of receiver.
    """
    SYSLOG = "Syslog"
    """
    Linux syslog.
    """
    AMA = "Ama"
    """
    Receives data from azure monitor agent receiver.
    """
    PIPELINE_GROUP = "PipelineGroup"
    """
    Receives data from another pipeline group.
    """
    OTLP = "OTLP"
    """
    Receives data from a OTLP collector.
    """
    UDP = "UDP"
    """
    Receives data from an UDP collector.
    """


class StreamEncodingType(str, Enum):
    """
    The encoding of the stream being received.
    """
    NOP = "nop"
    """
    No encoding validation. Treats the file as a stream of raw bytes.
    """
    UTF_8 = "utf-8"
    """
    UTF-8 encoding.
    """
    UTF_16LE = "utf-16le"
    """
    UTF-16 encoding with little-endian byte order.
    """
    UTF_16BE = "utf-16be"
    """
    UTF-16 encoding with little-endian byte order.
    """
    ASCII = "ascii"
    """
    ASCII encoding.
    """
    BIG5 = "big5"
    """
    The Big5 Chinese character encoding.
    """


class SyslogProtocol(str, Enum):
    """
    Protocol to parse syslog messages. Default rfc3164
    """
    RFC3164 = "rfc3164"
    """
    rfc3164 protocol.
    """
    RFC5424 = "rfc5424"
    """
    rfc5424 protocol.
    """
