# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from ._enums import *

__all__ = [
    'ApplicationPropertiesResponse',
    'SaasPropertiesResponse',
    'StatusResponse',
    'SystemDataResponse',
]

@pulumi.output_type
class ApplicationPropertiesResponse(dict):
    """
    Details about the Application that would use the Operator's Network APIs.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "applicationDescription":
            suggest = "application_description"
        elif key == "applicationType":
            suggest = "application_type"
        elif key == "legalName":
            suggest = "legal_name"
        elif key == "organizationDescription":
            suggest = "organization_description"
        elif key == "privacyContactEmailAddress":
            suggest = "privacy_contact_email_address"
        elif key == "taxNumber":
            suggest = "tax_number"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ApplicationPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ApplicationPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ApplicationPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 application_description: Optional[str] = None,
                 application_type: Optional[str] = None,
                 legal_name: Optional[str] = None,
                 name: Optional[str] = None,
                 organization_description: Optional[str] = None,
                 privacy_contact_email_address: Optional[str] = None,
                 tax_number: Optional[str] = None):
        """
        Details about the Application that would use the Operator's Network APIs.
        :param str application_description: Description of the application.
        :param str application_type: The category that describes the application.
        :param str legal_name: Legal name of the organization owning the application.
        :param str name: Name of the application. Example: Contoso App.
        :param str organization_description: A description of the organization owning the application.
        :param str privacy_contact_email_address: Email address of the Privacy contact or Data Protection officer of the organization.
        :param str tax_number: Unique Tax Number for the user's organization in the country/region the APC Gateway is being purchased.
        """
        if application_description is not None:
            pulumi.set(__self__, "application_description", application_description)
        if application_type is not None:
            pulumi.set(__self__, "application_type", application_type)
        if legal_name is not None:
            pulumi.set(__self__, "legal_name", legal_name)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if organization_description is not None:
            pulumi.set(__self__, "organization_description", organization_description)
        if privacy_contact_email_address is not None:
            pulumi.set(__self__, "privacy_contact_email_address", privacy_contact_email_address)
        if tax_number is not None:
            pulumi.set(__self__, "tax_number", tax_number)

    @property
    @pulumi.getter(name="applicationDescription")
    def application_description(self) -> Optional[str]:
        """
        Description of the application.
        """
        return pulumi.get(self, "application_description")

    @property
    @pulumi.getter(name="applicationType")
    def application_type(self) -> Optional[str]:
        """
        The category that describes the application.
        """
        return pulumi.get(self, "application_type")

    @property
    @pulumi.getter(name="legalName")
    def legal_name(self) -> Optional[str]:
        """
        Legal name of the organization owning the application.
        """
        return pulumi.get(self, "legal_name")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of the application. Example: Contoso App.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="organizationDescription")
    def organization_description(self) -> Optional[str]:
        """
        A description of the organization owning the application.
        """
        return pulumi.get(self, "organization_description")

    @property
    @pulumi.getter(name="privacyContactEmailAddress")
    def privacy_contact_email_address(self) -> Optional[str]:
        """
        Email address of the Privacy contact or Data Protection officer of the organization.
        """
        return pulumi.get(self, "privacy_contact_email_address")

    @property
    @pulumi.getter(name="taxNumber")
    def tax_number(self) -> Optional[str]:
        """
        Unique Tax Number for the user's organization in the country/region the APC Gateway is being purchased.
        """
        return pulumi.get(self, "tax_number")


@pulumi.output_type
class SaasPropertiesResponse(dict):
    """
    Details about the SaaS offer purchased from the marketplace.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "saasResourceId":
            suggest = "saas_resource_id"
        elif key == "saasSubscriptionId":
            suggest = "saas_subscription_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SaasPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SaasPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SaasPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 saas_resource_id: Optional[str] = None,
                 saas_subscription_id: Optional[str] = None):
        """
        Details about the SaaS offer purchased from the marketplace.
        :param str saas_resource_id: Resource ID of the SaaS offer purchased from the marketplace.
        :param str saas_subscription_id: Subscription ID of the SaaS offer purchased from the marketplace.
        """
        if saas_resource_id is not None:
            pulumi.set(__self__, "saas_resource_id", saas_resource_id)
        if saas_subscription_id is not None:
            pulumi.set(__self__, "saas_subscription_id", saas_subscription_id)

    @property
    @pulumi.getter(name="saasResourceId")
    def saas_resource_id(self) -> Optional[str]:
        """
        Resource ID of the SaaS offer purchased from the marketplace.
        """
        return pulumi.get(self, "saas_resource_id")

    @property
    @pulumi.getter(name="saasSubscriptionId")
    def saas_subscription_id(self) -> Optional[str]:
        """
        Subscription ID of the SaaS offer purchased from the marketplace.
        """
        return pulumi.get(self, "saas_subscription_id")


@pulumi.output_type
class StatusResponse(dict):
    """
    Description of the current status of the OperatorApiConnection resource.
    """
    def __init__(__self__, *,
                 reason: Optional[str] = None,
                 state: Optional[str] = None):
        """
        Description of the current status of the OperatorApiConnection resource.
        :param str reason: Explanation of the current state of the OperatorApiConnection resource.
        :param str state: Current state of the OperatorApiConnection resource.
        """
        if reason is not None:
            pulumi.set(__self__, "reason", reason)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def reason(self) -> Optional[str]:
        """
        Explanation of the current state of the OperatorApiConnection resource.
        """
        return pulumi.get(self, "reason")

    @property
    @pulumi.getter
    def state(self) -> Optional[str]:
        """
        Current state of the OperatorApiConnection resource.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The timestamp of resource last modification (UTC)
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


