# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListSystemActionsResult',
    'AwaitableListSystemActionsResult',
    'list_system_actions',
    'list_system_actions_output',
]

@pulumi.output_type
class ListSystemActionsResult:
    """
    List all actions for a system to perform.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[str]:
        """
        The link to fetch the next page of actions.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Sequence[Any]:
        """
        Array of actions.
        """
        return pulumi.get(self, "value")


class AwaitableListSystemActionsResult(ListSystemActionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListSystemActionsResult(
            next_link=self.next_link,
            value=self.value)


def list_system_actions(agent_resource_name: Optional[str] = None,
                        resource_group_name: Optional[str] = None,
                        system_resource_name: Optional[str] = None,
                        workspace_name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListSystemActionsResult:
    """
    List of actions for a business application system.
    Azure REST API version: 2024-04-01-preview.


    :param str agent_resource_name: Business Application Agent Name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str system_resource_name: The name of the system.
    :param str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['agentResourceName'] = agent_resource_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['systemResourceName'] = system_resource_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:securityinsights:listSystemActions', __args__, opts=opts, typ=ListSystemActionsResult).value

    return AwaitableListSystemActionsResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))


@_utilities.lift_output_func(list_system_actions)
def list_system_actions_output(agent_resource_name: Optional[pulumi.Input[str]] = None,
                               resource_group_name: Optional[pulumi.Input[str]] = None,
                               system_resource_name: Optional[pulumi.Input[str]] = None,
                               workspace_name: Optional[pulumi.Input[str]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListSystemActionsResult]:
    """
    List of actions for a business application system.
    Azure REST API version: 2024-04-01-preview.


    :param str agent_resource_name: Business Application Agent Name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str system_resource_name: The name of the system.
    :param str workspace_name: The name of the workspace.
    """
    ...
